#!/bin/sh
#
#  This file is part of Siena, a wide-area event notification system.
#  See http://www.cs.colorado.edu/serl/dot/siena.html
#
#  Author: Antonio Carzaniga <carzanig@cs.colorado.edu>
#  See the file AUTHORS for full details. 
#
#  Copyright (C) 1998-1999 University of Colorado
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
#  USA, or send email to serl@cs.colorado.edu.
#
#
# $Id: test_cover_direct.sh,v 1.1 2002/06/10 20:19:15 carzanig Exp $
#
. ./config
. $srcdir/base.sh
#
cat<<EOF
Tested Feature:		direct: simple filter covering

Topology:		no topology! direct functions calls
Interface functions:	-
Notification classes:	-
             types:	-
Filter classes:		single attribute, single constraint
       types:		string, integer, boolean, float
       operators:	any > < *
EOF
#
# --------------- TEST BEGINS HERE -----------------

testcovers yes 'filter{x any} filter{x=10}'
testcovers yes 'filter{x=10} filter{x=10}'
testcovers yes 'filter{x > 2} filter{x=10}'
testcovers yes 'filter{x != 2} filter{x=10}'
testcovers yes 'filter{x < 20} filter{x=10}'
testcovers yes 'filter{x <= 20} filter{x=10}'
testcovers yes 'filter{x >= 2} filter{x=10}'
testcovers no 'filter{x < 10} filter{x=10}'
testcovers no 'filter{x > 10} filter{x=10}'
testcovers no 'filter{x != 10} filter{x=10}'
testcovers no 'filter{x >= 11} filter{x=10}'
testcovers no 'filter{x <= 9} filter{x=10}'
testcovers no 'filter{x ="10"} filter{x=10}'
testcovers no 'filter{x = false} filter{x=10}'
testcovers no 'filter{x = true} filter{x=10}'
testcovers yes 'filter{x any} filter{x="abc"}'
testcovers yes 'filter{x >* "ab"} filter{x="abc"}'
testcovers yes 'filter{x *< "bc"} filter{x="abc"}'
testcovers yes 'filter{x != "xyz"} filter{x="abc"}'
testcovers yes 'filter{x < "azz"} filter{x="abc"}'
testcovers yes 'filter{x <= "abz"} filter{x="abc"}'
testcovers yes 'filter{x > "aba"} filter{x="abc"}'
testcovers yes 'filter{x >= "aba"} filter{x="abc"}'
testcovers yes 'filter{x * "b"} filter{x="abc"}'
testcovers yes 'filter{x="abc"} filter{x="abc"}'
testcovers no 'filter{x < "aac"} filter{x="abc"}'
testcovers no 'filter{x > "acc"} filter{x="abc"}'
testcovers no 'filter{x * "ba"} filter{x="abc"}'
testcovers no 'filter{x >* "ac"} filter{x="abc"}'
testcovers no 'filter{x *< "cc"} filter{x="abc"}'
testcovers no 'filter{x != "abc"} filter{x="abc"}'
testcovers no 'filter{x >= "abd"} filter{x="abc"}'
testcovers no 'filter{x <= "abb"} filter{x="abc"}'
#
testcovers yes 'filter{x any} filter{x = false}'
testcovers yes 'filter{x any} filter{x = true}'
testcovers yes 'filter{x any} filter{x > false}'
testcovers yes 'filter{x any} filter{x > true}'
testcovers yes 'filter{x any} filter{x < false}'
testcovers yes 'filter{x any} filter{x < true}'
testcovers yes 'filter{x any} filter{x <= false}'
testcovers yes 'filter{x any} filter{x <= true}'
testcovers yes 'filter{x any} filter{x >= true}'
testcovers yes 'filter{x any} filter{x >= false}'
testcovers yes 'filter{x any} filter{x != false}'
testcovers yes 'filter{x any} filter{x != true}'
#
testcovers yes 'filter{x any} filter{x = -10}'
testcovers yes 'filter{x any} filter{x = 20}'
testcovers yes 'filter{x any} filter{x > -10}'
testcovers yes 'filter{x any} filter{x > 20}'
testcovers yes 'filter{x any} filter{x < -10}'
testcovers yes 'filter{x any} filter{x < 20}'
testcovers yes 'filter{x any} filter{x <= 20}'
testcovers yes 'filter{x any} filter{x <= -10}'
testcovers yes 'filter{x any} filter{x >= 20}'
testcovers yes 'filter{x any} filter{x >= -10}'
testcovers yes 'filter{x any} filter{x != -10}'
testcovers yes 'filter{x any} filter{x != 20}'
#
testcovers yes 'filter{x any} filter{x = -1.234}'
testcovers yes 'filter{x any} filter{x = 5.678}'
testcovers yes 'filter{x any} filter{x > -1.234}'
testcovers yes 'filter{x any} filter{x > 5.678}'
testcovers yes 'filter{x any} filter{x < -1.234}'
testcovers yes 'filter{x any} filter{x < 5.678}'
testcovers yes 'filter{x any} filter{x <= 5.678}'
testcovers yes 'filter{x any} filter{x <= -1.234}'
testcovers yes 'filter{x any} filter{x >= 5.678}'
testcovers yes 'filter{x any} filter{x >= -1.234}'
testcovers yes 'filter{x any} filter{x != -1.234}'
testcovers yes 'filter{x any} filter{x != 5.678}'
#
testcovers yes 'filter{x any} filter{x = "xyz246"}'
testcovers yes 'filter{x any} filter{x = ""}'
testcovers yes 'filter{x any} filter{x > "xyz246"}'
testcovers yes 'filter{x any} filter{x > ""}'
testcovers yes 'filter{x any} filter{x < "xyz246"}'
testcovers yes 'filter{x any} filter{x < ""}'
testcovers yes 'filter{x any} filter{x <= ""}'
testcovers yes 'filter{x any} filter{x <= "xyz246"}'
testcovers yes 'filter{x any} filter{x >= ""}'
testcovers yes 'filter{x any} filter{x >= "xyz246"}'
testcovers yes 'filter{x any} filter{x != "xyz246"}'
testcovers yes 'filter{x any} filter{x != ""}'
testcovers yes 'filter{x any} filter{x *< ""}'
testcovers yes 'filter{x any} filter{x *< "xyz246"}'
testcovers yes 'filter{x any} filter{x >* ""}'
testcovers yes 'filter{x any} filter{x >* "xyz246"}'
testcovers yes 'filter{x any} filter{x * "xyz246"}'
testcovers yes 'filter{x any} filter{x * ""}'
#
testcovers yes 'filter{x != 10} filter{x = 0}'
testcovers yes 'filter{x != 10} filter{x != 10}'
testcovers yes 'filter{x != 10} filter{x < 0}'
testcovers yes 'filter{x != 10} filter{x < 10}'
testcovers yes 'filter{x != 10} filter{x <= 9}'
testcovers yes 'filter{x != 10} filter{x > 120}'
testcovers yes 'filter{x != 10} filter{x > 10}'
testcovers yes 'filter{x != 10} filter{x >= 11}'
testcovers no 'filter{x != 10} filter{x any}'
testcovers no 'filter{x != 10} filter{x = 10}'
testcovers no 'filter{x != 10} filter{x != 30}'
testcovers no 'filter{x != 10} filter{x > 0}'
testcovers no 'filter{x != 10} filter{x < 20}'
testcovers no 'filter{x != 10} filter{x <= 10}'
testcovers no 'filter{x != 10} filter{x > 1}'
testcovers no 'filter{x != 10} filter{x >= 10}'
#
testcovers yes 'filter{x != 10.5} filter{x = 0}'
testcovers yes 'filter{x != 10.5} filter{x = 10}'
testcovers yes 'filter{x != 10.5} filter{x != 10.5}'
testcovers yes 'filter{x != 10.5} filter{x < 0}'
testcovers yes 'filter{x != 10.5} filter{x < 10}'
testcovers yes 'filter{x != 10.5} filter{x <= 10}'
testcovers yes 'filter{x != 10.5} filter{x > 120}'
testcovers yes 'filter{x != 10.5} filter{x > 11}'
testcovers yes 'filter{x != 10.5} filter{x >= 11}'
testcovers no 'filter{x != 10.5} filter{x any}'
testcovers no 'filter{x != 10.5} filter{x = 10.5}'
testcovers no 'filter{x != 10.5} filter{x != 30}'
testcovers no 'filter{x != 10.5} filter{x > 0}'
testcovers no 'filter{x != 10.5} filter{x < 20}'
testcovers no 'filter{x != 10.5} filter{x <= 11}'
testcovers no 'filter{x != 10.5} filter{x > 1}'
testcovers no 'filter{x != 10.5} filter{x >= 10}'
#
testcovers yes 'filter{x != "xyz"} filter{x = "xyz246"}'
testcovers yes 'filter{x != "xyz"} filter{x > "xyz246"}'
testcovers yes 'filter{x != "xyz"} filter{x < "xxyyzz"}'
testcovers yes 'filter{x != "xyz"} filter{x <= "xyy"}'
testcovers yes 'filter{x != "xyz"} filter{x >= "xyza"}'
testcovers yes 'filter{x != "xyz"} filter{x != "xyz"}'
testcovers yes 'filter{x != "xyz"} filter{x *< "xyZ"}'
testcovers yes 'filter{x != "xyz"} filter{x >* "xyz246"}'
testcovers yes 'filter{x != "xyz"} filter{x * "xyh"}'
testcovers no 'filter{x != "xyz"} filter{x any}'
testcovers no 'filter{x != "xyz"} filter{x = "xyz"}'
testcovers no 'filter{x != "xyz"} filter{x > "xyac"}'
testcovers no 'filter{x != "xyz"} filter{x < "zxy"}'
testcovers no 'filter{x != "xyz"} filter{x <= "xyz"}'
testcovers no 'filter{x != "xyz"} filter{x >= "xyz"}'
testcovers no 'filter{x != "xyz"} filter{x != "abc"}'
testcovers no 'filter{x != "xyz"} filter{x *< "yz"}'
testcovers no 'filter{x != "xyz"} filter{x >* "xy"}'
testcovers no 'filter{x != "xyz"} filter{x * "x"}'
#
testcovers yes 'filter{x != true} filter{x = false}'
testcovers yes 'filter{x != true} filter{x != true}'
testcovers yes 'filter{x != true} filter{x < true}'
testcovers yes 'filter{x != true} filter{x <= false}'
testcovers no 'filter{x != true} filter{x >= false}'
testcovers no 'filter{x != true} filter{x any}'
testcovers no 'filter{x != true} filter{x = true}'
testcovers no 'filter{x != true} filter{x != false}'
testcovers no 'filter{x != true} filter{x > false}'
testcovers no 'filter{x != true} filter{x <= true}'
testcovers no 'filter{x != true} filter{x >= true}'
#
testcovers yes 'filter{x > "xyz"} filter{x = "xza"}'
testcovers yes 'filter{x > "xyz"} filter{x > "zzxyz246"}'
testcovers yes 'filter{x > "xyz"} filter{x >= "xyza"}'
testcovers yes 'filter{x > "xyz"} filter{x > "xzzzz"}'
testcovers yes 'filter{x > "xyz"} filter{x >* "za"}'
testcovers no 'filter{x > "xyz"} filter{x any}'
testcovers no 'filter{x > "xyz"} filter{x = "xaz"}'
testcovers no 'filter{x > "xyz"} filter{x > "xyac"}'
testcovers no 'filter{x > "xyz"} filter{x < "zzz"}'
testcovers no 'filter{x > "xyz"} filter{x <= "zzz"}'
testcovers no 'filter{x > "xyz"} filter{x >= "xyz"}'
testcovers no 'filter{x > "xyz"} filter{x *< "x"}'
testcovers no 'filter{x > "xyz"} filter{x >* "x"}'
testcovers no 'filter{x > "xyz"} filter{x >* "xyz"}'
testcovers no 'filter{x > "xyz"} filter{x * "y"}'
testcovers no 'filter{x > "xyz"} filter{x * "a"}'
#
testcovers yes 'filter{x > 10} filter{x = 20}'
testcovers yes 'filter{x > 10} filter{x > 15}'
testcovers yes 'filter{x > 10} filter{x >= 11}'
testcovers no 'filter{x > 10} filter{x any}'
testcovers no 'filter{x > 10} filter{x = 5}'
testcovers no 'filter{x > 10} filter{x > 5}'
testcovers no 'filter{x > 10} filter{x < 20}'
testcovers no 'filter{x > 10} filter{x <= 10}'
testcovers no 'filter{x > 10} filter{x >= 0}'
testcovers no 'filter{x > 10} filter{x != 10}'
#
echo PASSED
